#include "chdecl.h"
void CH_chcode_chgetoptions_proglit(current, sched, cop)
#define ARGUMENTS 4
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto c7;
    case 4: goto c9;
    case 5: goto c13;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
/* copy 4 3.0 */
  if((ch_returncode = cp_polymorph(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val;
  REF(4).tsdr = & dr_polymorph;
/* unwrap 3.1 4 , 2 */
  if ((ch_returncode = che_unwrap(DEF(3)DOT(1),DEF(4),QUAL(2)
    ,sched)) != Normal) goto ch_raise_exception;
/* endblock */
  che_endblock(sched);
/* branch , 9 */
   goto c9;
c7:
/* chs_lit 3.1 , "" */
  if( !chs_lit(DEF(3)DOT(1),"") ) goto ch_depletion;
c9:
/* discard 4 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c13:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
